% Get property from the specified object and return the value.
%   Call as:
%      get(obj), or
%      get(obj,prop_name)
%   where
%      obj       - object
%      prop_name - property name
%
%   The first form returns the list of property names as a string,
%   the second form returns the value of the named property.
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'matstates'}, {'material states for each gcell and each integration point'}}};
        return;
    else
        prop_name=varargin{1};
        switch prop_name
            case 'matstates'
                val = self.matstates;
            case 'feblock'
                val = self;
            otherwise
                val=get(self.feblock,varargin{:});
        end
    end
end
