% Get property from the specified object and return the value.
%
% function val = get(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'id'}, {'node identifier, positive integer'}};
            {{'xyz'}, {'coordinates of the node, array [dim,1], where dim = dimension of the embedding space'}};
            {{'xyz3'}, {'coordinates of the node, array [3,1]'}};
            {{'nfens'}, {'number of nodes in this set'}};
            };
        return;
    else
        prop_name=varargin{1};
        switch prop_name
            case 'id'
                val = self.id;
            case 'xyz'
                val = self.xyz;
            case 'xyz3'
                if (size(self.xyz,2)==1)
                    val = [self.xyz zeros(size(self.xyz,1),2)];
                elseif (size(self.xyz,2)==2)
                    val = [self.xyz zeros(size(self.xyz,1),1)];
                else
                    val = self.xyz;
                end
            case 'nfens'
                val =size(self.xyz,1);
            otherwise
                error(['Unknown property ''' prop_name '''!']);
        end
    end
end
