% Set property in the specified object.
%
% function retval = set(self,varargin)
% 
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
function retval = set(self,varargin)
    if (nargin == 1)
        retval = {{{'values'}, {'values of the nodal parameters, array [nfens,dim]'}};
            };
        return;
    end
    prop_name=varargin{1};
    val=varargin{2};
    switch prop_name
        case 'values'
            if (size(self.values)~=size(val))
                error(['Mismatched size of values array']);
            end
            self.values=val;
        otherwise
            error(['Unknown property ''' prop_name '''!']);
    end
    retval=self; % return self
end
