% Get force intensity magnitude at the specified point.
%
% function val = get_magn(self,xyz,J)
%
%  xyz=the location at which the force intensity needs to be evaluated
%  J= optional, Jacobian matrix of the geometric cell at which the force 
%  intensity is evaluated
function val = get_magn(self,xyz,J)
    if strcmp(class (self.magn),'inline') || strcmp(class (self.magn),'function_handle')
        if self.expect_J
            val=feval(self.magn,xyz,J);
        else
            val=feval(self.magn,xyz);
        end
        if length(val)==3
            val=reshape(val, 3, 1);
        end
    else
        val = self.magn;%  position- and orientation independent
    end
    return;
end
