% Constructor of a nine-node quadrilateral geometric cell.
%
% function retobj = gcellset_Q9(varargin)
%
% See discussion of constructors in <a href="matlab:helpwin 'FAESOR/classes/Contents'">classes/Contents</a>. 
% Parameters: same as gcellset_2_manifold.
%
function retobj = gcellset_Q9(varargin)
    class_name='gcellset_Q9';
    nfens=9;
    if (nargin == 0)
        Parameters.nfens=nfens;
        parent=gcellset_2_manifold(Parameters);
        retobj = class(struct([]),class_name, parent);
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
            return;
        else
            Parameters=varargin{1}; Parameters.nfens=nfens;
            parent=gcellset_2_manifold(Parameters);
            retobj = class(struct([]),class_name, parent);
            return;
        end
    else
        error('Illegal arguments!');
    end
    return;
end
