% Thick-walled cylinder (MacNeal, Harder standard test)
Omegatol=sqrt(10000*eps);
% Parameters:
E=1000;
nu=0.24;
uzex= 5.0399e-3;
R= 6;
t=6;
L=t;
ang=35/180*pi;
p=  1;
randshiftmult= 0.37;
randshiftmult= 0.2;
parshiftmult= 0.0006113;
parshiftmult= 0.;
% parshiftmult= 0.2;
graphics =   ~true;
scale=200;
A = [1.44,-0.741,-0.53; -0.626,1.589,-0.913; -0.55,0.43,1.756]+eye(3);
% A = [1.44,-0.741,0.53; -0.626,1.589,-0.913; -0.55,0.43,1.756];
% B = [0.1,-0.2, 0.3; 0.2, 0.1, 0.2; 0.1,-0.3, 0.2]/10;
% A = eye(3);

mix = 1;
clear mesd
mesd(mix).ref=[2:10];
mesd(mix).ref=[2:6];
% mesd(mix).ref=[7];
mesd(mix).ny=1;
mesd(mix).nc=1;
mesd(mix).nt=1;
mix = mix+1;

eix=1;
clear eltyd

% eltyd(eix).label ='T10';
% eltyd(eix).mf =@t4blockT10;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=tet_rule (4);
% eltyd(eix).surface_integration_rule=tri_rule(3);
% eltyd(eix).styl='kv--';
% eix=eix+1;

eltyd(eix).label ='NICE-T4';
eltyd(eix).mf =@t4block;
eltyd(eix).blf =@feblock_defor_ss_nicer;
eltyd(eix).integration_rule= simplex_nq_rule (3);
eltyd(eix).surface_integration_rule=tri_rule(1);
eltyd(eix).styl='m^-';
eix=eix+1;
% %
% eltyd(eix).label ='NICE-H8';
% eltyd(eix).mf =@block;
% eltyd(eix).blf =@feblock_defor_ss_nicer;
% eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',1));
% eltyd(eix).styl='md-';
% eix=eix+1;

% eltyd(eix).label ='NICE-H27';
% eltyd(eix).mf =@blockH27;
% eltyd(eix).blf =@feblock_defor_ss_nicer;
% eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
% eltyd(eix).styl='mh-';
% eix=eix+1;
%


% eltyd(eix).label ='H27';
% eltyd(eix).mf =@blockH27;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,3);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='ks-';
% eix=eix+1;
%
% eltyd(eix).label ='H20R';
% eltyd(eix).mf =@blockH20;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,2);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='ro-';
% eix=eix+1;
%
% eltyd(eix).label ='NICE-H20';
% eltyd(eix).mf =@blockH20;
% eltyd(eix).blf =@feblock_defor_ss_nicer;
% eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
% eltyd(eix).styl='mo--';
% eix=eix+1;
%
% eltyd(eix).label ='H20';
% eltyd(eix).mf =@blockH20;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule=gauss_rule (3,3);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
% eltyd(eix).styl='k>--';
% eix=eix+1;

for eix = 1:length(eltyd)
    disp(eltyd(eix).label);
    h=[];
    alpha=[];
    rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');

    for mix = 1:length(mesd)
        ns=[];
        uzs=[];
        neqns = [];

        for     ref=mesd(mix).ref;
            %% Create the mesh and initialize the geometry
            [fens,gcells]= feval (eltyd(eix).mf,t,t,t,mesd(mix).nc*ref,mesd(mix).ny*ref,mesd(mix).nt*ref);

            if parshiftmult~=0

                ax=parshiftmult*t;
                ay=parshiftmult*t;
                az=parshiftmult*t;
                fens = transform_apply(fens,@(x, data) (x +[-ax/2*x(3)^2*x(2),ay/2*x(3)*x(1)^2,az/4*x(1)^3*x(2)+ax/4*x(3)^2*sin(0.2*x(2)^3)]), []);
            end
              xy=get (fens,'xyz');
              for i=1:length (fens)
                xy(i,:)=xy(i,:)+xy(i,:)*(A);
                %                         get(fens(i),'id'),get(fens(i),'xyz')
            end
               fens=set(fens,'xyz', xy);
             [fens, gcells]=renum_mesh(fens, gcells);
            bdry_gcells = mesh_bdry(gcells, struct('other_dimension',1.0));
            
            if (graphics)
                mesh{1}=fens;
                mesh{2}=gcells;
                gv=drawmesh(mesh,'gcells','facecolor',[0.9,0.95,0.9],'edgecolor','black','shrink', 0.9);
                grid on; font ='Times';
                l=get(gca,'xlabel');
                set (l,'FontSize',14);                set(l,'FontName',font)
                l=get(gca,'ylabel');
                set (l,'FontSize',14);                set(l,'FontName',font)
                l=get(gca,'zlabel');
                set (l,'FontSize',14);                set(l,'FontName',font)
                l=gca;
                set (l,'FontSize',14);                set(l,'FontName',font)
%                 camset (gv, [])
             pause(1)
            end
            prop = property_linel_iso (struct('E',E,'nu',nu));
            mater = mater_defor_ss_linel_triax (struct('property',prop));

            feb = feval (eltyd(eix).blf, struct ('mater',mater,...
                'gcells',gcells, 'integration_rule',eltyd(eix).integration_rule));
            % ,'stabfact',0.1));
            geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));

            %% Define the displacement field, and zero it out
            u   = 0*geom;

            %% Apply the EBC''s
            nl=connected_nodes(bdry_gcells);
            u = set_ebc(u, nl, nl*0+1, nl*0+1, nl*0);
            u = set_ebc(u, nl, nl*0+1, nl*0+2, nl*0);
            u = set_ebc(u, nl, nl*0+1, nl*0+3, nl*0);
            u = apply_ebc (u);

            %% Number the equations
            u   = numbereqns (u);

            Gh = start (sparse_sysmat, get(u, 'neqns'));
            Gh = assemble (Gh, infsup_Gh(feb, geom, u));
                                Ghm =full (get(Gh,'mat'));
                                clear Gh
            Sh = start (sparse_sysmat, get(u, 'neqns'));
            Sh = assemble (Sh, infsup_Sh(feb, geom, u));
                                Shm=full (get(Sh,'mat'));
                                clear Sh
                                [modes,Omega]=eig(Ghm,Shm);
            % kpm=min([get(u, 'neqns'),(3*get(u, 'neqns')-get(u, 'neqns')+1)+2 ])
%             kpm =round(get(u, 'neqns')/8)
%             [modes,Omega]=eigs(get(Gh,'mat'),get(Sh,'mat'),kpm,'SM');
            clear Ghm Shm
            absOmega =diag(Omega);
            ix=find(absOmega<0);
            absOmega(ix)=0;
            absOmega =sqrt(sort(absOmega))';
            %                     loglog(absOmega,eltyd(eix).styl); hold on; pause(1);
            ix=find(absOmega>Omegatol);
            if isempty(ix)
                error (' Bad guess of the number of eigenvalues')
            end
            %         rank(Shm)-rank(Ghm)
            %         ix(1)
            format short
            alpha=[alpha,absOmega(ix(1))]
            h=[h,1/(length(fens))^(1/3)];
        end
    end
%     loglog(h,alpha,eltyd(eix).styl); hold on
%     set(gca,'YLim', [0.0001, 0.1]);
%     font='Times';
%     xlabel ('1/N')
%     ylabel ('\alpha')
%     h=legend(eltyd(eix).label,'Location','Southeast');
%     set (h,'FontSize', 16);
%     set(gca,'Position',[0.15 0.15 0.5 0.5]);
%     set(gca,'FontSize',14);
%     set(gca,'FontName',font)
%     l=get(gca,'xlabel');
%     set (l,'FontSize',16);
%     set(l,'FontName',font)
%     l=get(gca,'ylabel');
%     set (l,'FontSize',16);
%     set(l,'FontName',font)
%     hold on; grid on; figure (gcf);
%     print(gcf, '-r0', [mfilename '-' eltyd(eix).label '.eps'],'-deps2c');
%     figure(gcf)
%     close (gcf)
end
