function f
    
    kappa= 2*eye(2); % Isotropic conductivity matrix
    L =1e8;% latent heat
   cp = 2.5e6;
    Width = 1.0;
    Length = 1.0;
    Relax =0.95;
    maxit =4;
    dt =3600;
    dt =16*3600;
    tend =20*24*3600;
    Tn1Tol =1e-4;
    graphics = ~true; Style ='r-';
    scale = 0.1;
    Th =2;
    Tc =-4;
    Ti =2;
    Tm1=0-0.1; Tm2 =0 +0.1;
    function v=g(T)
        v=0*T;
        for jj=1:length(T)
            if (T<Tm1)
                v(jj)  =0.0;
            elseif (T>Tm2)
                v(jj) = 1.0;
            else
                v(jj)  = (T(jj)-Tm1)/(Tm2-Tm1);
            end
        end
        %     v
    end
    
    
    [fens,gcells] = Q4_block(Length, Width, 8,1,struct('other_dimension',1));
    prop = property_thermal_diffusion(struct('thermal_conductivity',kappa,...
        'specific_heat',cp,'source',0));
    mater=mater_diffusion(struct('property',prop));
    feb = feblock_thermal_nonlinear(struct ('mater',mater,...
        'gcells',gcells,...
        'integration_rule',tensprod_nq_rule (struct('dim',2,'order',1))));
    febpc = feblock_thermal_nonlinear(struct ('mater',mater,...
        'gcells',gcells,...
        'integration_rule',gauss_rule (2,15)));
    geom = field(struct('name',['geom'], 'dim', 2, 'fens',fens));
    tempn=field(struct('name',['tempn'], 'dim', 1, 'nfens',get(geom,'nfens')));
    tempn = tempn +Ti;% initial condition
    fenids=[fenode_select(fens,struct('box',[0 0 0 Width],...
        'inflate', 0.0001))];
    prescribed=ones(length(fenids),1);
    comp=[];
    val=zeros(length(fenids),1)+Tc;%  Cold
    tempn = set_ebc(tempn, fenids, prescribed, comp, val);
    fenids=[fenode_select(fens,struct('box',[Length Length 0 Width],...
        'inflate', 0.0001))];
    prescribed=ones(length(fenids),1);
    comp=[];
    val=zeros(length(fenids),1)+Th;% hot
    tempn = set_ebc(tempn, fenids, prescribed, comp, val);
    tempn = apply_ebc (tempn);
    tempn = numbereqns (tempn);
    
    gL = 0* tempn+1;% all liquidus
    

    V = start (sparse_sysmat, get(tempn, 'neqns'));
    V = assemble (V, lumped_volume(feb, geom, tempn));
    NV =get(V,'mat');
    

    K = start (sparse_sysmat, get(tempn, 'neqns'));
    K = assemble (K, conductivity(feb, geom, tempn));
    Kt =get(K,'mat');
    
    C = start (sparse_sysmat, get(tempn, 'neqns'));
    C = assemble (C, capacity(feb, geom, tempn));
    Ct =get(C,'mat');
    
    if (graphics)
        gv=graphic_viewer;
        gv=reset (gv,[]);
    else
        tref = [5.3247,20];Tref = [0.0,-1.95];
        plot(tref,Tref,'ko'); hold on
    end

    fen1id=[fenode_select(fens,struct('box',[0.25 0.25 0 0],...
        'inflate', 0.0001))];
    T1 = [];
    t= 0;
    while t<tend % Time stepping
        disp([' Time ' num2str(t)])
       T1= [T1,gather(tempn,fen1id,'values')];
        Tn = gather_sysvec(tempn);
        gLn = gather_sysvec(gL);
        Tn1 =Tn;
        gLn1 =gLn;
        tempn1 =tempn;
        pTn1= gather_sysvec(tempn1);
        %         gLn1 = predict_gL(@g,Tn1,Tn,gLn,L,NV,Ct)
        Ft = start (sysvec, get(tempn, 'neqns'));
        Ft = assemble (Ft, nz_ebc_loads_conductivity(feb, geom, tempn1));
        for i=1:maxit
            %                     if (graphics)
            % %                         gv=reset (gv,[]);
            %                         geomT=field(struct ('name', ['geomT'], ...
            %                             'data',[get(geom,'values'), get(tempn1,'values')]));
            %                         draw(feb, gv, struct ('x',geomT, 'u',0*geomT, 'facecolor','none','edgecolor',0*[0.49, 0.49, 0.49]));
            %                         drawnow; figure(gcf);
            %                     end
             Ftpc = start (sysvec, get(tempn, 'neqns'));
        Ftpc = assemble(Ftpc,phase_change_loads(febpc, geom, tempn, scatter_sysvec(0*gL, (gLn1-gLn)/dt),L));
%             r=phase_change_source(gLn1,gLn,dt,L,NV);
            Tn1=(1/dt*Ct+Kt)\(Ct*(1/dt*Tn)+get(Ft,'vec')+get(Ftpc,'vec'));

            gLn1 = update_gL(@g,gLn1,Tn1,Tm1,Tm2,L,NV,Ct,dt,Relax);
            tempn1 = scatter_sysvec(tempn1, Tn1);
            %             plot(gLn1); figure(gcf);
            nT=norm(Tn1-pTn1,Inf);
            disp([' Iteration ' num2str(i) ', norm(Tn1-pTn1)=' num2str(nT)]);
            if (nT<Tn1Tol)
                break;
            end
            pTn1 =Tn1;
        end
        pCt =Ct;
        t=t+dt;
        tempn =tempn1;
        gLn =gLn1;
        gL =scatter_sysvec(gL, gLn1);
        if (graphics)
            gv=reset (gv,[]);
            %         T=get(tempn1,'values');
            %         XY=get(geom,'values');
            %         conn=zeros(length (gcells),3);
            %         for i=1:length (gcells)
            %             conn(i,:)= get(gcells(i),'conn');
            %         end
            %         for i=1:length (gcells)
            %             draw(gcells(i), gv, struct ('x',geom, 'u',0*geom, 'facecolor','none','edgecolor',[0.49, 0.49, 0.49]));
            %         end
            %
            %         tricontour(XY,conn,T,15)
            %         view(2)
            T=get(tempn1,'values');
            dcm=data_colormap(struct ('range',[min(T),max(T)], 'colormap',hot(9)));
            colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, T)));
            geomT=field(struct ('name', ['geomT'], ...
                'data',[get(geom,'values'), scale*get(tempn1,'values')]));
            draw(feb, gv, struct ('x',geomT, 'u',0*geomT,...
                'colorfield',colorfield, 'shrink',1));
            draw(feb, gv, struct ('x',geom, 'u',0*geom, 'facecolor','none'));
            camset(gv, [-22.5860 -20.7612 12.5869 1.8371 0.0982 -0.3898 0 0 1.0 2.7437]);
            drawnow
        else
            plot(dt*(0:1:length(T1)-1)/(24*3600),T1,Style)
            grid on; drawnow
        end

    end
    %     figure
    %     plot(dt*(0:1:length(T1)-1),T1,'r-')
    %     grid on
end

function gLn1 = update_gL(g,gLn1,Tn1,Tm1,Tm2,L,NV,Ct,dt,Relax)
    for j=1:length(Tn1)
        if (gLn1(j)>0) && (gLn1(j)<1)
            Tn1g =Tm1 +gLn1(j)*(Tm2-Tm1);
        elseif (gLn1(j)<=0)
            Tn1g =Tm1;
        else
            Tn1g =Tm2;
        end
        gLn1(j) = gLn1(j) + (Relax)*Ct(j,j)/L/NV(j,j)*(Tn1(j)-Tn1g);
        if (gLn1(j)<0) gLn1(j)=0;end
        if (gLn1(j)>1) gLn1(j)=1;end
    end
end

% function v = phase_change_source(gLn1,gLn,dt,L,NV)
%     v=0*gLn1;
%     for j=1:length(gLn1)
%         v(j) =-L*(gLn1(j)-gLn(j))/dt*NV(j,j);
%     end
% end

% function gLn1 = predict_gL(g,Tn1,Tn,gLn,L,NV,Ct)
%     gLn1=0*gLn;
%     for j=1:length(gLn1)
%         gLn1(j) =solve_gT1(g,Tn1(j),Tn(j),gLn(j),L,NV(j,j),Ct(j,j));
%     end
% end
% 
% function v = solve_gT1(g,T1,T0,gL0,L,V,C)
%     v = fzero(@(g1)(C/L*(T1-T0) -(g1-gL0)*V),gL0);
%     if (v<0) v=0;end
%     if (v>1) v=1;end
% % T1s =-2: 0.01: 0; plot(T1s,C/L*(T1s-T0) -(g(T1s)-gL0)*V,'-');grid on;hold on
%     end
