function data=Beam_utilities
    date.Parameters=@Parameters;
    data.Torsional_constant=@Torsional_constant;
    data.Torsional_mass_moment_of_inertia=@Torsional_mass_moment_of_inertia;
    function J=Torsional_constant(shape)
        switch shape.type
            case 'circle'
                J=pi/2*shape.R^4;
            case 'hollow_circle'
                J=pi/2*(shape.Rext^4-shape.Rint^4);
            otherwise
                error([' Unknown type: ' char(shape.type)]);
        end
    end
    function J=Torsional_mass_moment_of_inertia(shape)
        switch shape.type
            case 'circle'
                J=pi*shape.R^4/2;
            otherwise
                error([' Unknown type: ' char(shape.type)]);
        end
    end
    function P=Parameters(shape)
        P.J=Torsional_constant(shape);
        P.I1=Torsional_mass_moment_of_inertia(shape);
    end
end