% Create a surface mesh of 1/8 of the sphere of "radius". 
%
% function [fens,gcells]=Q4_sphere(radius,nrefine,thickness)
%
% Create a mesh of 1/8 of the sphere of "radius". The  mesh will consist of
% three quadrilateral elements if "nrefine==0", or more if "nrefine>0".
% "nrefine" is the number of bisections applied  to refine the mesh.
% The quadrilaterals have thickness "thickness".
function [fens,gcells]=Q4_sphere(radius,nrefine,thickness)
    fens =fenodeset(struct('id',1:7,'xyz',[[1, 0, 0];[0, 1, 0];[0, 0, 1];[1, 1, 0];[0, 1, 1];[1, 0, 1];[1, 1, 1]]));
    gcells=gcellset_Q4(struct ('id', 1:3,'conn',[[1, 4, 7, 6];[4, 2, 5, 7]; [3, 6, 7, 5]],'other_dimension', thickness));
    fens= onto_sphere(fens, radius);
    for i=1:nrefine
        [fens,gcells]=Q4_refine(fens,gcells);
        fens= onto_sphere(fens, radius);
    end
end
