% Utilities
%
% Toolbox paths:
%   FAESOR_path                  - Return the path to the FAESOR topmost folder.
%   FAESOR_work_path             - Return the path to the FAESOR work folder.
% 
% Browsing of toolbox objects:
%   OB                          - The object browser helper function.
%   OBgui                       - The object browser GUI.
%   ars6                        - Array spreadsheet-like viewer.
%
% Graphics:
%   set_graphics_defaults       - set up graphics in a figure to a common
%                                     standard
%   progressbar                 - Display a status/progress bar and inform about the elapsed
%   savefig                     - Save a figure as an image.
%   show_field_as_arrows        - Visualize a field as arrows. 
%   streamplot                  - Plot the data as a stream tube.
%   sphereplot                  - Plot data evolving on a sphere.
%   tilefigs                    - Tile figure windows.
%   tricontour                  - Contouring for functions defined on triangular meshes
%   view3d                      - Interactively rotate, zoom and pan the view of a 3-D plot
%   showroom                    - Revolves a 3D plot showroom-style.
%   magnify                     - Install a magnification box into the current figure.
%   scan_on_image               - Collects points by scanning a curve in a graph image.
%   bwr                         - blue/white/red color map
%   cadcolors                   - Compute a standard CAD 10-color colormap.
%   cadcolors2                  - CAD colormap 12-color colormap.  
%   myaa                        - Render figure with anti-aliasing.
%   left_handed_axes            - Utility function to switch to left-handed graph
%                                  coordinate system
%   distance3dtool              - measure 3-D distance in a figure   
%   select3dtool                - select a 3-D point in a figure
%   select3d                    - helper for select3dtool
%   scan_on_image               -
%   labels                      - label the figure with LaTeX text
%   add_to_legend               - Add a label to legend                              
%    
% General utilities:
%   adeal                       - Deal values from input array to a number of outputs                                                    
%   somel                       - Grab some element(s) from an array
%   n2s0p                       - Format a number into a string  zero-padded to four digits.                  
%   @timetic                    - Timer class
%   clipboardpaste              - Paste from the system clipboard  
%   matchfieldname              - Match names of the fields of a structure      
% 
% Transformation utilities:
%   default_Rm                  - Compute transformation matrix describing local material directions.
%   geniso_Rm                   - Compute transformation matrix describing local material directions.
%   nd_Rm                       - Compute transformation matrix describing local material directions.
% 
% Folder and file utilities and typesetting:
%   convert                     - Convert between units from different systems.
%   highlight                   - Syntax Highlighting of Matlab M-files in HTML, LaTeX, RTF and XML.
%   matrix2latex                - print a matrix in LaTeX format
%   renderLaTeX2E               - render LaTeX text into an image
%   sniff_out                   - Search the folders and apply some function to matching files.
%   clean_sweep                 - Clean up in the current directory and its subdirectories by removing designated files.
%   make_patch                  - Make a file patch.
%   mlar                        - Matlab plain-text archiver.
%   replaceinfile               - Replace characters in a file
% 

  