function System_of_units=units(System_of_units,base_time_units)
%  UNITS - Initialize the unit conversion factors
% 
% function System_of_units=units(System_of_units,base_time_units)
% 
% Inputs:
% --System_of_units defaults to SI
% if System_of_units=='US', basic assumed units are American Engineering:
% LENGTH=uFT, TIME=uSEC, MASS=uSLUG TEMP=uRAN FORCE=uLB 
% if System_of_units=='CGS', basic assumed units are Centimeter,Gram,Second:
% LENGTH=uCM, TIME=uSEC, MASS=uGM TEMP=uK FORCE=uDYNE 
% otherwise, basic assumed units are SI:
% LENGTH=uM , TIME=uSEC, MASS=uKG   TEMP=uK   FORCE=uNT 
% --base_time_units defaults to SEC 
% 
% Outputs:  
%  System_of_units= this is the first input; if the first input was not
%  supplied then it returns the default.
% 
% Based on UNITS/GL_UNITS by Glenn Gomes, Version 2011.

if (~exist('System_of_units'))
    System_of_units='SI';
end
if (~exist('base_time_units'))
    base_time_units='SEC';
end

global base_system_of_units_global_Do_not_mess_with_this;
base_system_of_units_global_Do_not_mess_with_this.System_of_units=System_of_units;
base_system_of_units_global_Do_not_mess_with_this.base_time_units=base_time_units;
